Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cloudth_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cloudth_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cloudth_mod.F90	(revision 4482)
@@ -1146,5 +1146,7 @@
 
       ELSE IF (iflag_cloudth_vert == 5) THEN
-      sigma1s=(0.71794+0.000498239*dz(ind1,ind2))*(fraca(ind1,ind2)**0.5)/(1-fraca(ind1,ind2))*(((sth-senv)**2)**0.5)+ratqs(ind1,ind2)*po(ind1) !Environment
+         sigma1s=(0.71794+0.000498239*dz(ind1,ind2))*(fraca(ind1,ind2)**0.5) &
+              /(1-fraca(ind1,ind2))*(((sth-senv)**2)**0.5) &
+              +ratqs(ind1,ind2)*po(ind1) !Environment
       sigma2s=(0.03218+0.000092655*dz(ind1,ind2))/((fraca(ind1,ind2)+0.02)**0.5)*(((sth-senv)**2)**0.5)+0.002*zqta(ind1,ind2)                   !Thermals
       !sigma1s=(1.1**0.5)*(fraca(ind1,ind2)**0.6)/(1-fraca(ind1,ind2))*((sth-senv)**2)**0.5+0.002*po(ind1)
@@ -1414,5 +1416,7 @@
         !--------------------------------------------
       sigma_th=(0.03218+0.000092655*dz(ind1,ind2))/((fraca(ind1,ind2)+0.01)**0.5)*(((sth-senv)**2)**0.5)+0.002*zqta(ind1,ind2)
-      sigma_env=(0.71794+0.000498239*dz(ind1,ind2))*(fraca(ind1,ind2)**0.5)/(1-fraca(ind1,ind2))*(((sth-senv)**2)**0.5)+ratqs(ind1,ind2)*po(ind1)
+      sigma_env=(0.71794+0.000498239*dz(ind1,ind2))*(fraca(ind1,ind2)**0.5) &
+           /(1-fraca(ind1,ind2))*(((sth-senv)**2)**0.5) &
+           +ratqs(ind1,ind2)*po(ind1)
       xth=sth/(sqrt2*sigma_th)
       xenv=senv/(sqrt2*sigma_env)
@@ -1534,5 +1538,5 @@
 
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-SUBROUTINE cloudth_mpc(klon,klev,ind2,mpc_bl_points,                        &
+SUBROUTINE cloudth_mpc(klon,klev,ind2,iflag_mpc_bl,mpc_bl_points,           &
 &           temp,ztv,po,zqta,fraca,zpspsk,paprs,pplay,ztla,zthl,            &
 &           ratqs,zqs,snowflux,qcloud,qincloud,icefrac,ctot,ctot_vol)
@@ -1582,4 +1586,6 @@
       REAL, DIMENSION(klon),      INTENT(IN)      ::  zqs           ! Saturation specific humidity in the mesh [kg/kg]
       REAL, DIMENSION(klon,klev+1), INTENT(IN)    ::  snowflux      ! snow flux at the interface of the layer [kg/m2/s]
+      INTEGER,                      INTENT(IN)    ::  iflag_mpc_bl  ! option flag for mpc boundary layer clouds param.
+
 
       INTEGER, DIMENSION(klon,klev), INTENT(INOUT) :: mpc_bl_points  ! grid points with convective (thermals) mixed phase clouds
@@ -2020,5 +2026,7 @@
                 + (1.-1./(1.+C_mpc*qith(ind1,ind2))) * athl*(qsith(ind1,ind2)-qslth(ind1))  
 
-            sigma2sc=(sigma2s_factor*((MAX((sthlc-senvl),0.)**2)**0.5)/((fraca(ind1,ind2)+0.02)**sigma2s_power))+0.002*zqta(ind1,ind2)
+            sigma2sc=(sigma2s_factor*((MAX((sthlc-senvl),0.)**2)**0.5) &
+                 /((fraca(ind1,ind2)+0.02)**sigma2s_power)) &
+                 +0.002*zqta(ind1,ind2)
             deltasthc=athl*vert_alpha_th*sigma2sc
      
@@ -2166,5 +2174,7 @@
             ctot_vol(ind1,ind2)=fraca(ind1,ind2)*cth_vol(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv_vol(ind1,ind2)
             IF (qcth(ind1,ind2) .GT. 0) THEN
-                icefrac(ind1,ind2)=fraca(ind1,ind2)*qith(ind1,ind2)/(fraca(ind1,ind2)*qcth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qcenv(ind1,ind2))
+               icefrac(ind1,ind2)=fraca(ind1,ind2)*qith(ind1,ind2) &
+                    /(fraca(ind1,ind2)*qcth(ind1,ind2) &
+                    +(1.-1.*fraca(ind1,ind2))*qcenv(ind1,ind2))
                 icefrac(ind1,ind2)=MAX(MIN(1.,icefrac(ind1,ind2)),0.)
             ELSE
@@ -2386,5 +2396,7 @@
     AA=RLSTT/Ka/temp(ind2p1)*(RLSTT/RV/temp(ind2p1)-1.)
     BB=1./(rho(ind2p1)*Dv*qsith(ind2p1))
-    unsurtaustardep=C_cap*(Ni**0.66)*(qth(ind2p1)-qsith(ind2p1))/qsith(ind2p1)*4.*RPI/(AA+BB)*(6.*rho(ind2p1)/rhoi/RPI/Gamma(4.))**(0.33)
+    unsurtaustardep=C_cap*(Ni**0.66)*(qth(ind2p1)-qsith(ind2p1)) &
+         /qsith(ind2p1)*4.*RPI/(AA+BB) &
+         *(6.*rho(ind2p1)/rhoi/RPI/Gamma(4.))**(0.33)
     dep_term=rho(ind2p1)*fraca(ind2p1)*(qith(ind2p1)**0.33)*unsurtaustardep
  
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/coef_diff_turb_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/coef_diff_turb_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/coef_diff_turb_mod.F90	(revision 4482)
@@ -162,5 +162,5 @@
      
        IF (prt_level > 9) THEN
-          WRITE(lunout,*) 'USTAR = ',yustar
+          WRITE(lunout,*) 'USTAR = ',(yustar(i),i=1,knon)
        ENDIF
          
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/conf_phys_m.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/conf_phys_m.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/conf_phys_m.F90	(revision 4482)
@@ -133,9 +133,7 @@
     REAL, SAVE          :: f_rugoro_omp   , z0min_omp
     REAL, SAVE          :: z0m_seaice_omp,z0h_seaice_omp
+    REAL, SAVE          :: z0m_landice_omp,z0h_landice_omp
     REAL, SAVE          :: min_wind_speed_omp,f_gust_wk_omp,f_gust_bl_omp,f_qsat_oce_omp, f_z0qh_oce_omp
     INTEGER, SAVE       :: iflag_gusts_omp,iflag_z0_oce_omp
-
-    ! Local
-    REAL                 :: zzz
 
     REAL :: seuil_inversion
@@ -161,7 +159,8 @@
 
     REAL,SAVE :: R_ecc_omp,R_peri_omp,R_incl_omp,solaire_omp
-    REAL,SAVE      :: solaire_omp_init
+    REAL,SAVE :: solaire_omp_init
     LOGICAL,SAVE :: ok_suntime_rrtm_omp
     REAL,SAVE :: co2_ppm_omp, RCO2_omp, co2_ppm_per_omp, RCO2_per_omp
+    REAL,SAVE :: co2_ppm0_omp
     REAL,SAVE :: CH4_ppb_omp, RCH4_omp, CH4_ppb_per_omp, RCH4_per_omp
     REAL,SAVE :: N2O_ppb_omp, RN2O_omp, N2O_ppb_per_omp, RN2O_per_omp
@@ -186,5 +185,5 @@
     REAL,SAVE :: t_glace_min_omp, t_glace_max_omp
     REAL,SAVE :: exposant_glace_omp
-    INTEGER,SAVE :: iflag_gammasat_omp, iflag_mpc_bl_omp
+    INTEGER,SAVE :: iflag_gammasat_omp
     REAL,SAVE :: rei_min_omp, rei_max_omp
     INTEGER,SAVE :: iflag_sic_omp, iflag_inertie_omp
@@ -199,5 +198,4 @@
     REAL,SAVE :: cdmmax_omp,cdhmax_omp,ksta_omp,ksta_ter_omp,f_ri_cd_min_omp
     LOGICAL,SAVE :: ok_kzmin_omp
-    REAL, SAVE   :: pbl_lmixmin_alpha_omp
     REAL, SAVE ::  fmagic_omp, pmagic_omp
     INTEGER,SAVE :: iflag_pbl_omp,lev_histhf_omp,lev_histday_omp,lev_histmth_omp
@@ -227,4 +225,6 @@
     LOGICAL, SAVE :: ok_lic_cond_omp
     !
+    REAL, SAVE    :: zrel_oro_t_omp, zstd_orodr_t_omp
+    REAL, SAVE    :: zpmm_orodr_t_omp, zpmm_orolf_t_omp
     INTEGER, SAVE :: iflag_cycle_diurne_omp
     LOGICAL, SAVE :: soil_model_omp,new_oliq_omp
@@ -255,5 +255,4 @@
     LOGICAL, SAVE :: ok_new_lscp_omp
     LOGICAL, SAVE :: ok_icefra_lscp_omp
-    LOGICAL, SAVE :: ok_radliq_snow_omp
 
 
@@ -745,24 +744,24 @@
     !
     !Config Key  = co2_ppm
-    !Config Desc = concentration du gaz carbonique en ppmv
+    !Config Desc = concentration du CO2 en ppmv
     !Config Def  = 348.
     !Config Help = 
     !               
-    !
     !valeur AMIP II
     co2_ppm_omp = 348.
     CALL getin('co2_ppm', co2_ppm_omp)
     !
-    !Config Key  = RCO2
-    !Config Desc = Concentration du CO2
-    !Config Def  = co2_ppm * 1.0e-06  * 44.011/28.97
-    !Config Def  = 348. * 1.0e-06  * 44.011/28.97
+    !conversion en rapport de mélange massique
+    RCO2_omp = co2_ppm_omp * 1.0e-06 * RMCO2 / RMD
+
+    !
+    !Config Key  = co2_ppm0
+    !Config Desc = concentration initiale du CO2 en ppmv pour la version ESM avec CO2 interactif dans le cas 
+    !              où cette concentration de figure pas dans l'état de redémarrage de la physique
+    !Config Def  = 284.32
     !Config Help = 
     !               
-    ! RCO2 = 5.286789092164308E-04
-    !ancienne valeur
-    RCO2_omp = co2_ppm_omp * 1.0e-06 * RMCO2 / RMD ! pour co2_ppm=348.
-
-    !  CALL getin('RCO2', RCO2)
+    co2_ppm0_omp = 284.32
+    CALL getin('co2_ppm0', co2_ppm0_omp)
     !
     !Config Key  = RCH4
@@ -771,15 +770,7 @@
     !Config Help = 
     !               
-    !
-    !valeur AMIP II
-    !OK  RCH4 = 1.65E-06* 16.043/28.97
-    ! RCH4 = 9.137366240938903E-07
-    !
-    !ancienne valeur
-    ! RCH4 = 1.72E-06* 16.043/28.97
-    !OK CALL getin('RCH4', RCH4)
-    zzz = 1650.
-    CALL getin('CH4_ppb', zzz)
-    CH4_ppb_omp = zzz
+    CH4_ppb_omp = 1650.
+    CALL getin('CH4_ppb', CH4_ppb_omp)
+    !conversion en rapport de mélange massique
     RCH4_omp = CH4_ppb_omp * 1.0E-09 * RMCH4 / RMD
     !
@@ -789,15 +780,7 @@
     !Config Help = 
     !               
-    !
-    !valeur AMIP II
-    !OK  RN2O = 306.E-09* 44.013/28.97
-    ! RN2O = 4.648939592682085E-07
-    !
-    !ancienne valeur
-    ! RN2O = 310.E-09* 44.013/28.97
-    !OK  CALL getin('RN2O', RN2O)
-    zzz=306.
-    CALL getin('N2O_ppb', zzz)
-    N2O_ppb_omp = zzz
+    N2O_ppb_omp = 306.
+    CALL getin('N2O_ppb', N2O_ppb_omp)
+    !conversion en rapport de mélange massique
     RN2O_omp = N2O_ppb_omp * 1.0E-09 * RMN2O / RMD
     !
@@ -807,12 +790,8 @@
     !Config Help = 
     !               
-    !
-    !OK RCFC11 = 280.E-12* 137.3686/28.97
-    zzz = 280.
-    CALL getin('CFC11_ppt',zzz)
-    CFC11_ppt_omp = zzz
+    CFC11_ppt_omp = 280.
+    CALL getin('CFC11_ppt',CFC11_ppt_omp)
+    !conversion en rapport de mélange massique
     RCFC11_omp=CFC11_ppt_omp* 1.0E-12 * RMCFC11 / RMD
-    ! RCFC11 = 1.327690990680013E-09
-    !OK CALL getin('RCFC11', RCFC11)
     !
     !Config Key  = RCFC12
@@ -821,17 +800,12 @@
     !Config Help = 
     !               
-    !
-    !OK RCFC12 = 484.E-12* 120.9140/28.97
-    zzz = 484.
-    CALL getin('CFC12_ppt',zzz)
-    CFC12_ppt_omp = zzz
+    CFC12_ppt_omp = 484.
+    CALL getin('CFC12_ppt',CFC12_ppt_omp)
+    !conversion en rapport de mélange massique
     RCFC12_omp = CFC12_ppt_omp * 1.0E-12 * RMCFC12 / RMD
-    ! RCFC12 = 2.020102726958923E-09
-    !OK CALL getin('RCFC12', RCFC12)
-
-    !ajout CFMIP begin
+
     !
     !Config Key  = co2_ppm_per
-    !Config Desc = concentration du co2_ppm_per
+    !Config Desc = concentration du CO2 perturbé en ppmv (CFMIP)
     !Config Def  = 348.
     !Config Help = 
@@ -839,17 +813,6 @@
     co2_ppm_per_omp = co2_ppm_omp
     CALL getin('co2_ppm_per', co2_ppm_per_omp)
-    !
-    !Config Key  = RCO2_per
-    !Config Desc = Concentration du CO2_per
-    !Config Def  = co2_ppm_per * 1.0e-06  * 44.011/28.97
-    !Config Def  = 348. * 1.0e-06  * 44.011/28.97
-    !Config Help = 
-    !               
+    !conversion en rapport de mélange massique
     RCO2_per_omp = co2_ppm_per_omp * 1.0e-06 * RMCO2 / RMD
-
-    !Config Key  = ok_4xCO2atm
-    !Config Desc = Calcul ou non effet radiatif 4xco2
-    !Config Def  = .FALSE.
-    !Config Help = 
 
     !Config Key  = RCH4_per
@@ -858,7 +821,7 @@
     !Config Help = 
     !               
-    zzz = CH4_ppb_omp
-    CALL getin('CH4_ppb_per', zzz)
-    CH4_ppb_per_omp = zzz
+    CH4_ppb_per_omp = CH4_ppb_omp
+    CALL getin('CH4_ppb_per', CH4_ppb_per_omp)
+    !conversion en rapport de mélange massique
     RCH4_per_omp = CH4_ppb_per_omp * 1.0E-09 * RMCH4 / RMD
     !
@@ -868,7 +831,7 @@
     !Config Help = 
     !               
-    zzz = N2O_ppb_omp
-    CALL getin('N2O_ppb_per', zzz)
-    N2O_ppb_per_omp = zzz
+    N2O_ppb_per_omp = N2O_ppb_omp
+    CALL getin('N2O_ppb_per', N2O_ppb_per_omp)
+    !conversion en rapport de mélange massique
     RN2O_per_omp = N2O_ppb_per_omp * 1.0E-09 * RMN2O / RMD
     !
@@ -878,7 +841,7 @@
     !Config Help = 
     !               
-    zzz = CFC11_ppt_omp
-    CALL getin('CFC11_ppt_per',zzz)
-    CFC11_ppt_per_omp = zzz
+    CFC11_ppt_per_omp = CFC11_ppt_omp
+    CALL getin('CFC11_ppt_per',CFC11_ppt_per_omp)
+    !conversion en rapport de mélange massique
     RCFC11_per_omp=CFC11_ppt_per_omp* 1.0E-12 * RMCFC11 / RMD
     !
@@ -888,9 +851,8 @@
     !Config Help = 
     !               
-    zzz = CFC12_ppt_omp
-    CALL getin('CFC12_ppt_per',zzz)
-    CFC12_ppt_per_omp = zzz
+    CFC12_ppt_per_omp = CFC12_ppt_omp
+    CALL getin('CFC12_ppt_per',CFC12_ppt_per_omp)
+    !conversion en rapport de mélange massique
     RCFC12_per_omp = CFC12_ppt_per_omp * 1.0E-12 * RMCFC12 / RMD
-    !ajout CFMIP end
 
     !
@@ -937,4 +899,35 @@
     ok_orolf_omp = .TRUE.
     CALL getin('ok_orolf', ok_orolf_omp)
+
+
+    !Config  Key  =  zrel_oro_t
+    !Config  Desc = zrel_oro_t
+    !Config  Def  = 9999.
+    !Config  Help = Connais pas !
+    zrel_oro_t_omp = 9999.
+    CALL getin('zrel_oro_t', zrel_oro_t_omp)
+
+    !Config  Key  =  zstd_orodr_t
+    !Config  Desc = zstd_orodr_t
+    !Config  Def  = 0.
+    !Config  Help = Connais pas !
+    zstd_orodr_t_omp = 10.
+    CALL getin('zstd_orodr_t', zstd_orodr_t_omp)
+
+
+    !Config  Key  =  zpmm_orodr_t
+    !Config  Desc = zpmm_orodr_t
+    !Config  Def  = 0.
+    !Config  Help = Connais pas !
+    zpmm_orodr_t_omp = 100.
+    CALL getin('zpmm_orodr_t', zpmm_orodr_t_omp)
+
+
+    !Config  Key  =  zpmm_orolf_t
+    !Config  Desc = zpmm_orolf_t
+    !Config  Def  = 0.
+    !Config  Help = Connais pas !
+    zpmm_orolf_t_omp = 100.
+    CALL getin('zpmm_orolf_t', zpmm_orolf_t_omp)
 
     !Config  Key  = ok_limitvrai
@@ -1457,15 +1450,4 @@
 
     !
-    !Config Key  = iflag_mpc_bl
-    !Config Desc =
-    !Config Def  = 0
-    !Config Help =
-    !
-    iflag_mpc_bl_omp=0
-    CALL getin('iflag_mpc_bl',iflag_mpc_bl_omp)
-
-
-
-    !
     !Config Key  = iflag_t_glace
     !Config Desc =  
@@ -1635,7 +1617,4 @@
     ok_kzmin_omp = .TRUE.
     CALL getin('ok_kzmin',ok_kzmin_omp)
-
-    pbl_lmixmin_alpha_omp=0.0
-    CALL getin('pbl_lmixmin_alpha',pbl_lmixmin_alpha_omp)
 
     !
@@ -2123,4 +2102,8 @@
     z0m_seaice_omp = 0.002 ; CALL getin('z0m_seaice',z0m_seaice_omp)
     z0h_seaice_omp = 0.002 ; CALL getin('z0h_seaice',z0h_seaice_omp)
+
+
+    z0m_landice_omp = 0.001 ; CALL getin('z0m_landice',z0m_landice_omp)
+    z0h_landice_omp = 0.001 ; CALL getin('z0h_landice',z0h_landice_omp)
 
     f_rugoro_omp = 0.
@@ -2376,12 +2359,4 @@
     !Config Help = ...
 
-
-    ok_radliq_snow_omp = .FALSE.
-    CALL getin('ok_radliq_snow', ok_radliq_snow_omp)
-    !
-    !Config Key  = ok_radliq_snow_omp
-    !Config Desc = take into account snowfall for radiation
-    !Config Def  = .FALSE.
-    !Config Help = ...
 
     ecrit_LES_omp = 1./8.
@@ -2434,4 +2409,5 @@
     ok_suntime_rrtm = ok_suntime_rrtm_omp
     co2_ppm = co2_ppm_omp
+    co2_ppm0 = co2_ppm0_omp
     RCO2 = RCO2_omp
     CH4_ppb = CH4_ppb_omp
@@ -2459,4 +2435,8 @@
     ok_orodr = ok_orodr_omp
     ok_orolf = ok_orolf_omp
+    zrel_oro_t=zrel_oro_t_omp
+    zstd_orodr_t=zstd_orodr_t_omp
+    zpmm_orodr_t=zpmm_orodr_t_omp
+    zpmm_orolf_t=zpmm_orolf_t_omp
     ok_limitvrai = ok_limitvrai_omp
     nbapp_rad = nbapp_rad_omp
@@ -2500,5 +2480,4 @@
     exposant_glace = exposant_glace_omp
     iflag_gammasat=iflag_gammasat_omp
-    iflag_mpc_bl=iflag_mpc_bl_omp
     iflag_t_glace = iflag_t_glace_omp
     iflag_cloudth_vert=iflag_cloudth_vert_omp
@@ -2520,5 +2499,4 @@
     f_ri_cd_min = f_ri_cd_min_omp
     ok_kzmin = ok_kzmin_omp
-    pbl_lmixmin_alpha=pbl_lmixmin_alpha_omp
     fmagic = fmagic_omp
     pmagic = pmagic_omp
@@ -2666,4 +2644,6 @@
     z0m_seaice=z0m_seaice_omp
     z0h_seaice=z0h_seaice_omp
+    z0m_landice=z0m_landice_omp
+    z0h_landice=z0h_landice_omp
 
     f_rugoro=f_rugoro_omp
@@ -2708,5 +2688,4 @@
     ok_new_lscp = ok_new_lscp_omp
     ok_icefra_lscp=ok_icefra_lscp_omp
-    ok_radliq_snow=ok_radliq_snow_omp
     read_fco2_ocean_cor = read_fco2_ocean_cor_omp
     var_fco2_ocean_cor = var_fco2_ocean_cor_omp
@@ -2863,4 +2842,5 @@
     WRITE(lunout,*) ' ok_suntime_rrtm =',ok_suntime_rrtm
     WRITE(lunout,*) ' co2_ppm =',co2_ppm
+    WRITE(lunout,*) ' co2_ppm0 =',co2_ppm0
     WRITE(lunout,*) ' RCO2_act = ',RCO2_act
     WRITE(lunout,*) ' CH4_ppb =',CH4_ppb,' RCH4_act = ',RCH4_act
@@ -2881,4 +2861,8 @@
     WRITE(lunout,*) ' ok_orodr=',ok_orodr
     WRITE(lunout,*) ' ok_orolf=',ok_orolf
+    WRITE(lunout,*) ' zrel_oro_t=',zrel_oro_t
+    WRITE(lunout,*) ' zstd_orodr_t=',zstd_orodr_t
+    WRITE(lunout,*) ' zpmm_orodr_t=',zpmm_orodr_t
+    WRITE(lunout,*) ' zpmm_orolf_t=',zpmm_orolf_t
     WRITE(lunout,*) ' ok_limitvrai=',ok_limitvrai
     WRITE(lunout,*) ' nbapp_rad=',nbapp_rad
@@ -2929,5 +2913,4 @@
     WRITE(lunout,*) ' exposant_glace = ',exposant_glace
     WRITE(lunout,*) ' iflag_gammasat = ',iflag_gammasat
-    WRITE(lunout,*) ' iflag_mpc_bl = ',iflag_mpc_bl
     WRITE(lunout,*) ' iflag_t_glace = ',iflag_t_glace
     WRITE(lunout,*) ' iflag_cloudth_vert = ',iflag_cloudth_vert
@@ -2948,5 +2931,4 @@
     WRITE(lunout,*) ' f_ri_cd_min = ',f_ri_cd_min 
     WRITE(lunout,*) ' ok_kzmin = ',ok_kzmin 
-    WRITE(lunout,*) ' pbl_lmixmin_alpha = ',pbl_lmixmin_alpha
     WRITE(lunout,*) ' fmagic = ',fmagic
     WRITE(lunout,*) ' pmagic = ',pmagic
@@ -3048,5 +3030,4 @@
     WRITE(lunout,*) ' ok_new_lscp = ', ok_new_lscp
     WRITE(lunout,*) ' ok_icefra_lscp = ', ok_icefra_lscp
-    WRITE(lunout,*) ' ok_radliq_snow = ', ok_radliq_snow
     WRITE(lunout,*) ' read_climoz = ', read_climoz
     WRITE(lunout,*) ' carbon_cycle_tr = ', carbon_cycle_tr
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cpl_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cpl_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cpl_mod.F90	(revision 4482)
@@ -49,6 +49,8 @@
   !$OMP THREADPRIVATE(cpl_snow,cpl_evap,cpl_tsol)
 
-  REAL, ALLOCATABLE, SAVE:: cpl_delta_sst(:), cpl_delta_sal(:)
-  !$OMP THREADPRIVATE(cpl_delta_sst, cpl_delta_sal)
+  REAL, ALLOCATABLE, SAVE:: cpl_delta_sst(:), cpl_delta_sal(:), cpl_dter(:), &
+       cpl_dser(:), cpl_dt_ds(:)
+  !$OMP THREADPRIVATE(cpl_delta_sst, cpl_delta_sal, cpl_dter, cpl_dser)
+  !$OMP THREADPRIVATE(cpl_dt_ds)
   
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_fder, cpl_albe, cpl_taux, cpl_tauy
@@ -64,4 +66,6 @@
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_rriv2D, cpl_rcoa2D, cpl_rlic2D
   !$OMP THREADPRIVATE(cpl_rriv2D,cpl_rcoa2D,cpl_rlic2D)
+  REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: rlic_in_frac2D  ! fraction for continental ice
+  !$OMP THREADPRIVATE(rlic_in_frac2D)
 
 ! variables read from coupler :
@@ -94,6 +98,8 @@
   !$OMP THREADPRIVATE(cpl_snow2D, cpl_evap2D, cpl_tsol2D)
 
-  REAL, ALLOCATABLE, SAVE:: cpl_delta_sst_2D(:,:), cpl_delta_sal_2D(:,:)
+  REAL, ALLOCATABLE, SAVE:: cpl_delta_sst_2D(:, :), cpl_delta_sal_2D(:, :), &
+       cpl_dter_2D(:, :), cpl_dser_2D(:, :), cpl_dt_ds_2D(:, :)
   !$OMP THREADPRIVATE(cpl_delta_sst_2D, cpl_delta_sal_2D)
+  !$OMP THREADPRIVATE(cpl_dter_2D, cpl_dser_2D, cpl_dt_ds_2D)
 
   REAL, ALLOCATABLE, DIMENSION(:,:,:), SAVE :: cpl_fder2D, cpl_albe2D
@@ -226,4 +232,6 @@
     ALLOCATE(cpl_rlic2D(nbp_lon,jj_nb), stat=error)
     sum_error = sum_error + error
+    ALLOCATE(rlic_in_frac2D(nbp_lon,jj_nb), stat=error)
+    sum_error = sum_error + error
     ALLOCATE(read_sst(nbp_lon, jj_nb), stat = error)
     sum_error = sum_error + error
@@ -238,5 +246,6 @@
     
        if (activate_ocean_skin == 2) then
-          ALLOCATE(cpl_delta_sst(klon), cpl_delta_sal(klon), stat = error)
+          ALLOCATE(cpl_delta_sst(klon), cpl_delta_sal(klon), cpl_dter(klon), &
+               cpl_dser(klon), cpl_dt_ds(klon), stat = error)
           sum_error = sum_error + error
        end if
@@ -650,5 +659,5 @@
        precip_rain, precip_snow, evap, tsurf, fder, albsol, taux, tauy, windsp,&
        sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol, delta_sst, &
-       delta_sal)
+       delta_sal, dTer, dSer, dt_ds)
 
     ! This subroutine cumulates some fields for each time-step during
@@ -683,4 +692,16 @@
     real, intent(in):: delta_sal(:) ! (knon)
     ! Ocean-air interface salinity minus bulk salinity, in ppt.
+
+    REAL, intent(in):: dter(:) ! (knon)
+    ! Temperature variation in the diffusive microlayer, that is
+    ! ocean-air interface temperature minus subskin temperature. In
+    ! K.
+
+    REAL, intent(in):: dser(:) ! (knon)
+    ! Salinity variation in the diffusive microlayer, that is
+    ! ocean-air interface salinity minus subskin salinity. In ppt.
+
+    real, intent(in):: dt_ds(:) ! (knon)
+    ! (tks / tkt) * dTer, in K
 
 ! Local variables
@@ -722,4 +743,7 @@
           cpl_delta_sst = 0.
           cpl_delta_sal = 0.
+          cpl_dter = 0.
+          cpl_dser = 0.
+          cpl_dt_ds = 0.
        end if
     ENDIF
@@ -768,4 +792,7 @@
           cpl_delta_sst(ig) = cpl_delta_sst(ig) + delta_sst(ig) / REAL(nexca)
           cpl_delta_sal(ig) = cpl_delta_sal(ig) + delta_sal(ig) / REAL(nexca)
+          cpl_dter(ig) = cpl_dter(ig) + dter(ig) / REAL(nexca)
+          cpl_dser(ig) = cpl_dser(ig) + dser(ig) / REAL(nexca)
+          cpl_dt_ds(ig) = cpl_dt_ds(ig) + dt_ds(ig) / REAL(nexca)
        end if
      ENDDO
@@ -817,5 +844,7 @@
           if (activate_ocean_skin == 2) then
              ALLOCATE(cpl_delta_sst_2D(nbp_lon, jj_nb), &
-                  cpl_delta_sal_2D(nbp_lon, jj_nb), stat = error)
+                  cpl_delta_sal_2D(nbp_lon, jj_nb), &
+                  cpl_dter_2D(nbp_lon, jj_nb), cpl_dser_2D(nbp_lon, jj_nb), &
+                  cpl_dt_ds_2D(nbp_lon, jj_nb), stat = error)
              sum_error = sum_error + error
           end if
@@ -878,4 +907,7 @@
           CALL gath2cpl(cpl_delta_sst, cpl_delta_sst_2D, knon, knindex)
           CALL gath2cpl(cpl_delta_sal, cpl_delta_sal_2D, knon, knindex)
+          CALL gath2cpl(cpl_dter, cpl_dter_2D, knon, knindex)
+          CALL gath2cpl(cpl_dser, cpl_dser_2D, knon, knindex)
+          CALL gath2cpl(cpl_dt_ds, cpl_dt_ds_2D, knon, knindex)
        end if
     ENDIF
@@ -1151,5 +1183,5 @@
 !
 
-  SUBROUTINE cpl_send_landice_fields(itime, knon, knindex, rlic_in)
+  SUBROUTINE cpl_send_landice_fields(itime, knon, knindex, rlic_in, rlic_in_frac)
 ! This subroutine cumulates the field for melting ice for each time-step 
 ! during a coupling period. This routine will not send to coupler. Sending 
@@ -1165,4 +1197,7 @@
     INTEGER, DIMENSION(klon), INTENT(IN)      :: knindex
     REAL, DIMENSION(klon), INTENT(IN)         :: rlic_in
+    REAL, DIMENSION(klon), INTENT(IN)         :: rlic_in_frac  ! Fraction for continental ice, can be equal to 
+                                                               ! pctsrf(:,is_lic) or not, depending on landice_opt
+    
 
 ! Local varibales
@@ -1179,5 +1214,5 @@
 !$OMP END MASTER
     CALL gath2cpl(rlic_in, rlic2D, knon, knindex)
-
+    CALL gath2cpl(rlic_in_frac(:), rlic_in_frac2D(:,:), knon, knindex) 
 !*************************************************************************************
 ! Reset field to zero in the beginning of a new coupling period 
@@ -1276,4 +1311,7 @@
        tab_flds(:, :, ids_delta_sst) = cpl_delta_sst_2D
        tab_flds(:, :, ids_delta_sal) = cpl_delta_sal_2D
+       tab_flds(:, :, ids_dter) = cpl_dter_2D
+       tab_flds(:, :, ids_dser) = cpl_dser_2D
+       tab_flds(:, :, ids_dt_ds) = cpl_dt_ds_2D
     end if
     
@@ -1298,5 +1336,7 @@
     CALL gath2cpl(pctsrf(:,is_oce), pctsrf2D(:,:,is_oce), klon, unity)
     CALL gath2cpl(pctsrf(:,is_sic), pctsrf2D(:,:,is_sic), klon, unity)
-    CALL gath2cpl(pctsrf(:,is_lic), pctsrf2D(:,:,is_lic), klon, unity)
+
+
+
 
 !*************************************************************************************
@@ -1311,5 +1351,5 @@
         DO j = 1, jj_nb
            tmp_calv(:,j) = DOT_PRODUCT (cpl_rlic2D(1:nbp_lon,j), &
-                pctsrf2D(1:nbp_lon,j,is_lic)) / REAL(nbp_lon)
+                rlic_in_frac2D(1:nbp_lon,j)) / REAL(nbp_lon)
         ENDDO
     
@@ -1348,5 +1388,5 @@
             calving(k)=0
             DO j = 1, jj_nb
-               calving(k)= calving(k)+DOT_PRODUCT(cpl_rlic2D(:,j)*area_calving(:,j,k),pctsrf2D(:,j,is_lic))
+               calving(k)= calving(k)+DOT_PRODUCT(cpl_rlic2D(:,j)*area_calving(:,j,k),rlic_in_frac2D(:,j))
             ENDDO
          ENDDO
@@ -1513,5 +1553,6 @@
     ENDIF
 
-    if (activate_ocean_skin == 2) deallocate(cpl_delta_sst_2d, cpl_delta_sal_2d)
+    if (activate_ocean_skin == 2) deallocate(cpl_delta_sst_2d, &
+         cpl_delta_sal_2d, cpl_dter_2d, cpl_dser_2d, cpl_dt_ds_2d)
 
     IF (sum_error /= 0) THEN
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_etat0_limit_unstruct.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_etat0_limit_unstruct.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_etat0_limit_unstruct.F90	(revision 4482)
@@ -89,5 +89,4 @@
                 abort_message='create_etat0_limit_unstruct, Initial state file are created, all is fine' 
                 CALL abort_physic(modname,abort_message,0)
-                STOP 0
               ENDIF
 !$OMP BARRIER
@@ -110,5 +109,4 @@
               abort_message='create_etat0_limit_unstruct, Initial state file are created, all is fine' 
               CALL abort_physic(modname,abort_message,0)
-              STOP 0
           ENDIF
         ENDIF
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_etat0_unstruct.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_etat0_unstruct.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_etat0_unstruct.F90	(revision 4482)
@@ -53,4 +53,5 @@
   USE phys_state_var_mod
   USE indice_sol_mod
+  USE surface_data,      ONLY: landice_opt
   USE mod_phys_lmdz_para
   USE print_control_mod, ONLY: lunout
@@ -83,5 +84,5 @@
       CALL xios_recv_field("qs",qsol_mpi)
       CALL xios_recv_field("mask",zmasq_mpi)
-      CALL xios_recv_field("landice",lic_mpi)
+      IF (landice_opt .LT. 2) CALL xios_recv_field("landice",lic_mpi)
       CALL xios_recv_field("zmea",zmea_mpi)
       CALL xios_recv_field("zstd",zstd_mpi)
@@ -93,5 +94,5 @@
     CALL scatter_omp(qsol_mpi,qsol)
     CALL scatter_omp(zmasq_mpi,zmasq)
-    CALL scatter_omp(lic_mpi,lic)
+    IF (landice_opt .LT. 2) CALL scatter_omp(lic_mpi,lic)
     CALL scatter_omp(zmea_mpi,zmea)
     CALL scatter_omp(zstd_mpi,zstd)
@@ -110,25 +111,35 @@
 
     pctsrf(:,:) = 0
-    pctsrf(:,is_lic)=lic
-    WHERE(pctsrf(:,is_lic)<EPSFRA) pctsrf(:,is_lic)=0. 
-    WHERE(zmasq(:)<EPSFRA)         pctsrf(:,is_lic)=0.
-
-    pctsrf(:,is_ter)=zmasq(:)
-
-!--- Adequation with soil/sea mask
-    DO ji=1,klon
-      IF(zmasq(ji)>EPSFRA) THEN 
-        IF(pctsrf(ji,is_lic)>=zmasq(ji)) THEN
-          pctsrf(ji,is_lic)=zmasq(ji)
-          pctsrf(ji,is_ter)=0.
-        ELSE
-          pctsrf(ji,is_ter)=zmasq(ji)-pctsrf(ji,is_lic)
-          IF(pctsrf(ji,is_ter)<EPSFRA) THEN
-            pctsrf(ji,is_ter)=0.
-            pctsrf(ji,is_lic)=zmasq(ji)
-          END IF 
-        END IF 
-      END IF 
-    END DO 
+    IF (landice_opt .LT. 2) THEN
+       pctsrf(:,is_lic)=lic
+       WHERE(pctsrf(:,is_lic)<EPSFRA) pctsrf(:,is_lic)=0.
+       WHERE(zmasq(:)<EPSFRA)         pctsrf(:,is_lic)=0.
+
+       pctsrf(:,is_ter)=zmasq(:)
+       
+       !--- Adequation with soil/sea mask
+       DO ji=1,klon
+          IF(zmasq(ji)>EPSFRA) THEN 
+             IF(pctsrf(ji,is_lic)>=zmasq(ji)) THEN
+                pctsrf(ji,is_lic)=zmasq(ji)
+                pctsrf(ji,is_ter)=0.
+             ELSE
+                pctsrf(ji,is_ter)=zmasq(ji)-pctsrf(ji,is_lic)
+                IF(pctsrf(ji,is_ter)<EPSFRA) THEN
+                   pctsrf(ji,is_ter)=0.
+                   pctsrf(ji,is_lic)=zmasq(ji)
+                END IF
+             END IF
+          END IF
+       END DO
+   
+    ELSE
+       ! landice_opt=>2 : no land ice
+       pctsrf(:,is_lic)=0.0
+       pctsrf(:,is_ter)=zmasq(:)
+    END IF
+
+
+
 
 
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_limit_unstruct.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_limit_unstruct.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_limit_unstruct.F90	(revision 4482)
@@ -111,8 +111,8 @@
       WHERE(NINT(zmasq(:))/=1) rugos(:,l)=0.001
     ENDDO
-    CALL time_interpolation(ndays,rugos,'360d',rugos_year)
+    CALL time_interpolation(ndays,rugos,'360_day',rugos_year)
 
 ! albedo    
-    CALL time_interpolation(ndays,albedo,'360d',albedo_year)
+    CALL time_interpolation(ndays,albedo,'360_day',albedo_year)
 
 
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cv30_routines.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cv30_routines.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cv30_routines.F90	(revision 4482)
@@ -3349,5 +3349,5 @@
            write(*,*) 'clw(i,k)=',clw(i,k)
            write(*,*) 'cpd,cpv=',cpd,cpv
-           CALL abort_physic(modname,abort_message,0)
+           CALL abort_physic(modname,abort_message,1)
         endif
        enddo !do k=1,nl
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/dyn1d/1DUTILS.h
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/dyn1d/1DUTILS.h	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/dyn1d/1DUTILS.h	(revision 4482)
@@ -1708,9 +1708,9 @@
 
 !
-        print *,'dtime, tau ',dtime,tau
-        print *, 'u_targ',u_targ
-        print *, 'v_targ',v_targ
-        print *,'zonal velocity ',u
-        print *,'meridional velocity ',v
+        !print *,'dtime, tau ',dtime,tau
+        !print *, 'u_targ',u_targ
+        !print *, 'v_targ',v_targ
+        !print *,'zonal velocity ',u
+        !print *,'meridional velocity ',v
         DO k = 1,klev
          DO i = 1,klon
@@ -1721,6 +1721,6 @@
             d_v(i,k) = d_v(i,k) + 1./tau*(v_targ(i,k)-v(i,k))
 !
-            print *,' k,u,d_u,v,d_v ',    &
-                      k,u(i,k),d_u(i,k),v(i,k),d_v(i,k)
+!           print *,' k,u,d_u,v,d_v ',    &
+!                     k,u(i,k),d_u(i,k),v(i,k),d_v(i,k)
 !           ENDIF
 !
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/dyn1d/1D_interp_cases.h
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/dyn1d/1D_interp_cases.h	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/dyn1d/1D_interp_cases.h	(revision 4482)
@@ -10,5 +10,5 @@
 !    &       ,year_ini_cas,day_ju_ini_cas,nt_cas,pdt_cas,nlev_cas                           &
      &       ,nt_cas,nlev_cas                                                               &
-     &       ,ts_cas,ps_cas,plev_cas,t_cas,th_cas,thv_cas,thl_cas,qv_cas,ql_cas,qi_cas      &
+     &       ,ts_cas,tskin_cas,ps_cas,plev_cas,t_cas,th_cas,thv_cas,thl_cas,qv_cas,ql_cas,qi_cas      &
      &       ,u_cas,v_cas,ug_cas,vg_cas                                                     &
      &       ,temp_nudg_cas,qv_nudg_cas,u_nudg_cas,v_nudg_cas                               &
@@ -19,5 +19,5 @@
      &       ,uw_cas,vw_cas,q1_cas,q2_cas,tkes_cas                                           &
 !
-     &       ,ts_prof_cas,ps_prof_cas,plev_prof_cas,t_prof_cas,theta_prof_cas,thv_prof_cas  &
+     &       ,ts_prof_cas,tskin_prof_cas,ps_prof_cas,plev_prof_cas,t_prof_cas,theta_prof_cas,thv_prof_cas  &
      &       ,thl_prof_cas,qv_prof_cas,ql_prof_cas,qi_prof_cas                              &
      &       ,u_prof_cas,v_prof_cas,ug_prof_cas,vg_prof_cas                                 &
@@ -31,5 +31,9 @@
      &       ,sens_prof_cas,ustar_prof_cas,uw_prof_cas,vw_prof_cas,q1_prof_cas,q2_prof_cas,tkes_prof_cas)
 ! EV tg instead of ts_cur
-             tg = ts_prof_cas 
+             tg = ts_prof_cas
+             if ((tg .eq. 0.) .and. (tskin_prof_cas .ne. 0.)) then
+                tg=tskin_prof_cas
+              endif
+
 !            psurf=plev_prof_cas(1)
              psurf=ps_prof_cas
